// #include <f2c.h>
#include <stdio.h>
#include <clapack.h>

#define SIZE 4

/**
void MAIN_(){}
void MAIN__(){}
void _MAIN_(){}
**/

int main( )
{
	char JOBU;
	char JOBVT;

	int i, j;
	
	int M = SIZE;  // rows
	int N = 3;  // cols
	
	int LDA = M;   // The leading dimension of the array A.  LDA >= max(1,M)
	int LDU = M;  // The leading dimension of the array U.  LDU >= 1; if
                  //           JOBU = 'S' or 'A', LDU >= M. 
	int LDVT = N;
	int LWORK;
	int INFO;
   
	int mn = M < N ? M : M;

	int MN = M > N ? M : N;
	 
	// A, la matrix dimension (LDA,N)
	double a[12] = { 16.0, 2.0, 3.0, 13.0, 5.0, 11.0, 10.0, 8.0, 9.0, 7.0, 6.0, 12.0};
	double s[SIZE];        // Los valores singulares. Dimension (min(M,N))
	double work[201];      // dimension MAX(1,LWORK), LWORK >= MAX( 1, 5*MIN(M,N) )
	double uu[16];  // La matrix U, dimension (LDU,UCOL)
	double vt[9];  // La matrix V, dimension (LDVT,N)

	// The leading dimension of the array VT.  LDVT >= 1; if
	// JOBVT = 'A', LDVT >= N; if JOBVT = 'S', LDVT >= min(M,N).

	 
	JOBU = 'A';
	// JOBU = 'N';   //  no columns of U (no left singular vectors) are computed.
	 
	JOBVT = 'A';
	 
	LWORK =  201;
	
/* Subroutine int dgesvd_(char *jobu, char *jobvt, integer *m, integer *n, 
        doublereal *a, integer *lda, doublereal *s, doublereal *u, integer * ldu,
        doublereal *vt, integer *ldvt, doublereal *work, integer *lwork, 
        integer *info)

DGESVD
DGESDD
 SUBROUTINE DGESVD( JOBU, JOBVT, M, N, A, LDA, S, U, LDU, VT, LDVT,
*                          WORK, LWORK, INFO )
* 
14 argumentos

2 char
7 int
5 vectores

int dgesdd_(char *jobz, __CLPK_integer *m, __CLPK_integer *n, __CLPK_doublereal *
    a, __CLPK_integer *lda, __CLPK_doublereal *s, __CLPK_doublereal *u, __CLPK_integer *ldu,
    __CLPK_doublereal *vt, __CLPK_integer *ldvt, __CLPK_doublereal *work, __CLPK_integer *lwork,
    __CLPK_integer *iwork, __CLPK_integer *info) __OSX_AVAILABLE_STARTING(__MAC_10_2,__IPHONE_4_0);

1 char
7 int
1 int *
5 double * (vector)

char jobz = 'A' 
int m  // rows
int n  // cols
a size (LDA,N)
int lda = m
vector s  // dimension (min(M,N)), and singular values are ordered
vector u  // dimension (LDU,M)
int ldu  // = m 
vector vt // dimension dimension (LDVT,N) 
int LDVT >= N;
vector work
int lwork // dimension min(M,N)*(6+4*min(M,N))+max(M,N)
            N*(6 + 4*N)+M

vector iwork // dimension (8*min(M,N))
int info
            



*/
	dgesvd_( &JOBU, &JOBVT, &M, &N, a, &LDA, s, uu, 
		  &LDU, vt, &LDVT, work, &LWORK, &INFO);
		  
	printf("INFO=%d\n", INFO );		  

	for ( i= 0; i< SIZE; i++ ) {
		printf("s[ %d ] = %lf\n", i, s[ i ] );
	}

	for ( i= 0; i< SIZE; i++ ) {
		for ( j= 0; j< SIZE; j++ ) 
			printf("%lf ", vt[ SIZE*i + j ] );
		printf("\n");
	}
	return 0;
}	 
